using System;
using System.Text;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;
namespace ConsoleApplicationVector2
{
    class Vector<T>
    {
        private List<T> list;
        private Node<T> last;
        private int numValues;

        public Vector()
        {
            this.list = new List<T>();
            this.last = null;
            this.numValues = 0;
        }

        public void Add(T x)
        {
            Node<T> pos = null;

            if (!this.list.IsEmpty())
                pos = this.last;

            this.last = this.list.Insert(pos, x);
            this.numValues++;
        }

        public void Del(int place)
        {
            if (place == 1)
            {
                if (this.last == this.list.GetFirst())
                    this.last = null;
                this.list.Remove(this.list.GetFirst());
            }
            else
            {
                Node<T> prev = this.list.GetFirst();

                for (int i = 1; i <= place - 2; i++)
                    prev = prev.GetNext();

                if (this.last == prev.GetNext())
                    this.last = prev;
                this.list.Remove(prev.GetNext());
            }

            this.numValues--;
        }

        public T Get(int place)
        {
            Node<T> pos = this.list.GetFirst();

            for (int i = 1; i <= place - 1; i++)
                pos = pos.GetNext();

            return (pos.GetInfo());
        }

        public void Set(int place, T x)
        {
            Node<T> pos = this.list.GetFirst();

            for (int i = 1; i <= place - 1; i++)
                pos = pos.GetNext();

            pos.SetInfo(x);
        }

        public int Length()
        {
            return (this.numValues);
        }

        public override String ToString()
        {
            String str = "";

            if (!this.list.IsEmpty())
            {
                Node<T> pos = this.list.GetFirst();

                while (pos != this.last)
                {
                    str = str + pos.GetInfo().ToString() + ",";
                    pos = pos.GetNext();
                }
                str = str + last.GetInfo().ToString();
            }
            return (str);
        }
    }
}
